const __doOK = doOK;
const prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);

var pref_name;
var domain_pairs;
var document_id;
var _cert;

function onload() {

    onLoad(); // call chrome://pippki/content/domainMismatch.js onLoad event
              // *or* chrome://pippki/content/serverCertExpired.js onLoad event

    document_id = document.firstChild.id.toUpperCase(); // "DOMAINMISMATCH" or "SERVERCERTEXPIRED"

        // queryInteface
    var isupport = pkiParams.getISupportAtIndex(1);
    _cert = isupport.QueryInterface(nsIX509Cert);
    var not_after_str = _cert.validity.notAfter.toString();

        // which prefs are we after
    if (document_id == "DOMAINMISMATCH"){
        pref_name = "remember_mismatched_domains.domain_pairs"; // use domain pairs prefs
    } else if (document_id == "SERVERCERTEXPIRED"){
        pref_name = "remember_mismatched_domains.expired_pairs";  // use expired pairs prefs
    }

        // gather prefs
    domain_pairs = "";
    if (prefs.getPrefType(pref_name) == prefs.PREF_STRING){
        domain_pairs = prefs.getCharPref(pref_name);
    }
    var pairs_array = domain_pairs.split(" ");
    for (var i in pairs_array){
        var cert_data = pairs_array[i].split(":")[0]; // either domain or date
        cert_data = unescape(cert_data);
        var cert_url = pairs_array[i].split(":")[1];
        cert_url = unescape(cert_url);
        var cert_fingerprint_sha1 = pairs_array[i].split(":")[2]; // sha1 (as stored)
        cert_fingerprint_sha1 = unescape(cert_fingerprint_sha1);
        var cert_fingerprint_md5 = pairs_array[i].split(":")[3]; // md5 (as stored)
        cert_fingerprint_md5 = unescape(cert_fingerprint_md5);

        var bypass_dialog = false;
        if (document_id == "DOMAINMISMATCH"){
            if (cert_data == dialogParams.GetString(1) &&
                cert_url == _cert.commonName &&
                cert_fingerprint_sha1 == _cert.sha1Fingerprint &&
                cert_fingerprint_md5 == _cert.md5Fingerprint){
                    bypass_dialog = true;
            }
        } else if (document_id == "SERVERCERTEXPIRED"){
            if (cert_data == _cert.validity.notAfter &&
                cert_url == _cert.commonName &&
                cert_fingerprint_sha1 == _cert.sha1Fingerprint &&
                cert_fingerprint_md5 == _cert.md5Fingerprint){
                    bypass_dialog = true;
            }
        }
        if (bypass_dialog){ // bypass dialog window
            dialogParams.SetInt(1,1);
            window.focus();
            window.close();
            break;
        }
    }
}
doOK = function(){
    if (document.getElementById('rmd-checkbox').checked){ // don't warn checkbox is selected so remember the pair
        if (document_id == "DOMAINMISMATCH"){
            domain_pairs += escape( dialogParams.GetString(1) ) + ":" + escape( _cert.commonName );
        } else if (document_id == "SERVERCERTEXPIRED"){
            domain_pairs += escape( _cert.validity.notAfter ) + ":" + escape( _cert.commonName );
        }
        domain_pairs += ":" + escape( _cert.sha1Fingerprint ) + ":" + escape( _cert.md5Fingerprint ) + " "; // fingerprints too
        prefs.setCharPref(pref_name, domain_pairs); // store prefs
    }
    __doOK(); // call chrome://pippki/content/domainMismatch.js doOK()
              // *or* chrome://pippki/content/serverCertExpired.js doOK()
}

